Subject: bug#65904: 29.1.50; autorevert can't revert files in a symlink directory

From: zhanghj <[email-masked]>
Date: Tue, 19 Sep 2023 05:08:46 +0800

I tried your patch on GNU/Linux. It works as you said(the same as in 
Emacs 26/27 now). I will try it on macOS later.

I have added some debug message and see that without this patch, the 
`filenotiy' also watch the file but `autorevert.el` can't receives 
events for the test file. After applying the patch, it can receive 
events for the test file. It seems that the patch is not harmful. Can 
you apply it in Emacs 29?

Thanks.

On 9/14/23 19:58, Michael Albinus wrote:
> zhanghj <[email-masked]> writes:
>
> Hi,
>
>> How does it work in Emacs 26/27? Why don't you let it keep the old behavior?
> That time, it was unspecified, whether symlinked files/directories are
> watched. Some file notification backends did, other backends didn't. In
> Emacs 29, this was clarified, see (info "(elisp) File Notifications")
>
> --8<---------------cut here---------------start------------->8---
>       If FILE is a symlink, it doesn’t follow that link.  Just FILE
>       itself will be watched.
> --8<---------------cut here---------------end--------------->8---
>
> There is the idea to add a new flag to the `file-notify-add-watch'
> function, `follow'. This would allow to follow symlinks, with different
> implementations in the different backends. Buth this hasn't been
> implemented yet.
>
> If you need this feature urgently in inotify (I guess you're using this
> backend), try the appended patch in filenotify.el (untested).
>
> Best regards, Michael.
>